﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace Smith.NED
{
    public static class FileDialogs
    {
        public static bool Execute(string filter, ref string filepath)
        {
            OpenFileDialog ofd = new OpenFileDialog();
            ofd.Filter = filter;
            ofd.FileName = filepath;
            for (; ; )
            {
                if (ofd.ShowDialog() != DialogResult.OK)
                    return false;

                if (!FileOperations.IsContainer(ofd.FileName))
                {
                    filepath = ofd.FileName;
                    return true;
                }

                OpenFromContainer ofc = new OpenFromContainer();
                ofc.SetContainer(ofd.FileName);
                ofc.SetFilter(filter);
                if (ofc.ShowDialog() == DialogResult.OK)
                {
                    filepath = ofc.FileName;
                    return true;
                }
            }
        }
    }
}
