﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Smith.NED
{
    public static class FindUtils
    {
        public enum CompAction
        {
            None,
            Equal,
            NotEqual,
            Above,
            Below,
            In,
            NotIn
        }

        public class QBase
        {
            public CompAction act = CompAction.None;
        }

        public class QInt : QBase
        {
            public int v;
        }

        public class QString : QBase
        {
            public string v;
        }

        public class QFlags : QBase
        {
            public uint v;
        }

        public class QDouble : QBase
        {
            public double v;
        }

        public class SectorFindInfo
        {
            public QInt num = new QInt();
            public QInt nsurfs = new QInt();
            public QFlags flags = new QFlags();
            public QDouble extra_l = new QDouble();
            public QString colormap = new QString();
            public QDouble tint_r = new QDouble();
            public QDouble tint_g = new QDouble();
            public QDouble tint_b = new QDouble();
            public QString sound = new QString();
            public QDouble sound_vol = new QDouble();
            public QString layer = new QString();
        }

        public class SurfFindInfo
        {
            public QInt num = new QInt();
            public QString material = new QString();
            public QInt adjoinSC = new QInt();
            public QInt adjoinSF = new QInt();
            public QFlags adjoinFlags = new QFlags();
            public QFlags surfFlags = new QFlags();
            public QFlags faceFlags = new QFlags();
            public QInt geo = new QInt();
            public QInt light = new QInt();
            public QInt tex = new QInt();
            public QDouble extra_l = new QDouble();
            public QString layer = new QString();
        }

        public class ThingFindInfo
        {
            public QInt num = new QInt();
            public QString name = new QString();
            public QInt sec = new QInt();
            public QDouble x = new QDouble();
            public QDouble y = new QDouble();
            public QDouble z = new QDouble();
            public QDouble pch = new QDouble();
            public QDouble yaw = new QDouble();
            public QDouble rol = new QDouble();
            public QString layer = new QString();
        }
    }
}
