﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Smith.NED
{
    public partial class FlagEdit : GUI.BaseForm
    {
        public static void EditMPModes(ref uint flags)
        {
            FlagEdit f = new FlagEdit(flags);
            f.Bit(0, "Capture the flag");
            f.Bit(1, "Tag");
            f.Bit(2, "Kill fool with chicken");
            f.Bit(3, "Secret doc");
            f.Bit(4, "Team Play");
            f.Bit(5, "Death match");
            if (f.ShowDialog() == DialogResult.OK)
                flags = f.Choice;
        }

        public static void EditEntityMask(ref uint flag)
        {
            FlagEdit f = new FlagEdit(flag);
            f.Bit(0, "Enemy");
            f.Bit(3, "Weapon");
            f.Bit(31, "Player");
            if (f.ShowDialog() == DialogResult.OK)
                flag = f.Choice;
        }

        public static void EditEventMask(ref uint flag)
        {
            FlagEdit f = new FlagEdit(flag);
            f.Bit(0, "Cross from inside");
            f.Bit(1, "Cross from outside");
            f.Bit(2, "Enter sector");
            f.Bit(3, "Leave sector");
            f.Bit(4, "Nudge from inside");
            f.Bit(5, "Nudge from outside");
            f.Bit(6, "Blow up");
            //f.Bit(7, "Shoot");
            f.Bit(8, "Shoot");
            f.Bit(14, "NWX message");
            f.Bit(16, "Cutom event 1");
            f.Bit(17, "Cutom event 2");
            f.Bit(18, "Cutom event 3");
            f.Bit(19, "Cutom event 4");
            f.Bit(20, "Cutom event 5");
            f.Bit(21, "Cutom event 6");
            f.Bit(22, "Cutom event 7");
            f.Bit(23, "Cutom event 8");
            f.Bit(24, "Cutom event 9");
            f.Bit(25, "Cutom event 10");
            if (f.ShowDialog() == DialogResult.OK)
                flag = f.Choice;
        }

        public static void EditSectorFlags(ref uint flag)
        {
            FlagEdit f = new FlagEdit(flag);
            f.Bit(0, "No Gravity");
            f.Bit(1, "Underwater", "Underwater Sector");
            f.Bit(2, "Used in COG", "Refrenced by a COG");
            f.Bit(3, "Has thrust", "Sector has Thrust");
            f.Bit(4, "Hide on map", "Don't show sector on map");
            f.Bit(5, "No AI", "AI can't enter this sector");
            f.Bit(6, "Pit", "If you fall here, screen fades");
            f.Bit(7, "Turn adjoins off");
            f.Bit(10, "Draw on map");
            f.Bit(12, "Has Collide box", "System flag - ignore");
            f.Bit(31, "Preview as 3DO", "JED flag - show inverted in 3D preview");
            if (f.ShowDialog() == DialogResult.OK)
                flag = f.Choice;
        }

        public static void EditSurfaceFlags(ref uint flag)
        {
            FlagEdit f = new FlagEdit(flag);
            f.Bit(0, "Floor", "Appears on map and isn't slippery");
            f.Bit(1, "Used in COG", "Refrenced by a COG");
            f.Bit(2, "Impassible");
            f.Bit(3, "Not walkable by AI");
            f.Bit(4, "Double tx scale");
            f.Bit(5, "Half tx scale");
            f.Bit(6, "1/8 tx scale");
            f.Bit(7, "No damage from fall");
            f.Bit(9, "Sky");
            f.Bit(10, "Sky (Different type)");
            f.Bit(11, "Scrolling");
            f.Bit(12, "Icy");
            f.Bit(13, "Very icy");
            f.Bit(14, "Magsealed", "Reflects shots");
            f.Bit(16, "Metal", "Steps make metal sound");
            f.Bit(17, "Deep water");
            f.Bit(18, "Shallow water");
            f.Bit(19, "Dirt", "Steps make dirt sound");
            f.Bit(20, "Very deep water");
            f.Bit(31, "Texture Flipped");
            if (f.ShowDialog() == DialogResult.OK)
                flag = f.Choice;
        }

        public static void EditAdjoinFlags(ref uint flag)
        {
            FlagEdit f = new FlagEdit(flag);
            f.Bit(0, "Render past adjoin");
            f.Bit(1, "Passable");
            f.Bit(2, "Doesn't block sound");
            f.Bit(3, "Impassable for AI");
            f.Bit(4, "Impassable for player");
            f.Bit(31, "Blocks light");
            if (f.ShowDialog() == DialogResult.OK)
                flag = f.Choice;
        }

        public static void EditThingFlags(ref uint flag)
        {
            FlagEdit f = new FlagEdit(flag);
            f.Bit(0, "Emits light");
            f.Bit(1, "Dead");
            f.Bit(2, "Magsealed", "Reflects shots");
            f.Bit(3, "Architecture", "Object should be rendered as part of world architecture");
            f.Bit(4, "Invisible");
            f.Bit(6, "Can be stood on");
            f.Bit(8, "Controlled remotely");
            f.Bit(9, "Dying");
            f.Bit(10, "Used in COG");
            f.Bit(11, "Not crushing", "Won't damage things it crushes");
            f.Bit(12, "Not present on Easy");
            f.Bit(13, "Not present on Medium");
            f.Bit(14, "Not present on Hard");
            f.Bit(15, "Not present on Multiplayer");
            f.Bit(16, "Not present on Singleplayer");
            f.Bit(19, "Disabled");
            f.Bit(22, "Metal", "Object made of metal");
            f.Bit(23, "Earth", "Object made of earthen materials");
            f.Bit(24, "No sound", "Object makes no sound");
            f.Bit(25, "Submerged", "Object is submerged");
            f.Bit(26, "Prelit");
            f.Bit(27, "Air only", "Object can't live in water");
            f.Bit(28, "Water only", "Object can't live in air");
            f.Bit(29, "makes splash");
            if (f.ShowDialog() == DialogResult.OK)
                flag = f.Choice;
        }

        public static void EditFaceFlags(ref uint flag)
        {
            FlagEdit f = new FlagEdit(flag);
            f.Bit(1, "Translucent", "Half-Transparent");
            if (f.ShowDialog() == DialogResult.OK)
                flag = f.Choice;
        }

        public static void EditLevelITMFlags(ref uint flag)
        {
            FlagEdit f = new FlagEdit(flag);
            f.Bit(0, "Dump weapons");
            f.Bit(1, "Dump ammo");
            f.Bit(2, "Dump health");
            f.Bit(3, "Dump oil");// WTF lol
            f.Bit(4, "Dump all");
            f.Bit(5, "Show score");
            if (f.ShowDialog() == DialogResult.OK)
                flag = f.Choice;
        }

        public static void EditLightFlags(ref uint flag)
        {
            FlagEdit f = new FlagEdit(flag);
            f.Bit(0, "Not blocked", "Not blocked by geometry");
            if (f.ShowDialog() == DialogResult.OK)
                flag = f.Choice;
        }

        List<CheckBox> cbs = new List<CheckBox>();

        public uint Choice
        {
            get
            {
                uint f = 0;
                for (int x = 0; x < 32; x++)
                    if (cbs[x].Checked)
                        f |= (uint)(1 << x);
                return f;
            }

            set
            {
                for (int x = 0; x < 32; x++)
                    cbs[x].Checked = (value & (uint)(1 << x)) != 0;
            }
        }

        public FlagEdit(uint initalValue)
        {
            InitializeComponent();

            cbs.Add(checkBox1);
            cbs.Add(checkBox2);
            cbs.Add(checkBox3);
            cbs.Add(checkBox4);
            cbs.Add(checkBox5);
            cbs.Add(checkBox6);
            cbs.Add(checkBox7);
            cbs.Add(checkBox8);
            cbs.Add(checkBox9);
            cbs.Add(checkBox10);
            cbs.Add(checkBox11);
            cbs.Add(checkBox12);
            cbs.Add(checkBox13);
            cbs.Add(checkBox14);
            cbs.Add(checkBox15);
            cbs.Add(checkBox16);
            cbs.Add(checkBox17);
            cbs.Add(checkBox18);
            cbs.Add(checkBox19);
            cbs.Add(checkBox20);
            cbs.Add(checkBox21);
            cbs.Add(checkBox22);
            cbs.Add(checkBox23);
            cbs.Add(checkBox24);
            cbs.Add(checkBox25);
            cbs.Add(checkBox26);
            cbs.Add(checkBox27);
            cbs.Add(checkBox28);
            cbs.Add(checkBox29);
            cbs.Add(checkBox30);
            cbs.Add(checkBox31);
            cbs.Add(checkBox32);

            for (int x = 0; x < 32; x++)
            {
                cbs[x].Text = "Unknown/Unused (Flag " + x.ToString() + ")";
            }

            Choice = initalValue;
        }

        public void Bit(int i, string nm, string dsc = null)
        {
            cbs[i].Text = nm;
            if (!string.IsNullOrEmpty(dsc))
                toolTip1.SetToolTip(cbs[i], dsc);
        }
    }
}
