﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Smith.NED
{
    public partial class LevelHeaderEditor : GUI.BaseForm
    {
        public LevelHeaderEditor()
        {
            InitializeComponent();
        }

        private void LevelHeaderEditor_Load(object sender, EventArgs e)
        {
            JKLHeader h = GlobalVars.Level.header;

            EBGravity.Text = h.gravity.ToString();
            EBSkyZ.Text = h.ceilingskyZ.ToString();
            EBSkyOffsX.Text = h.ceilingSkyOff.x.ToString();
            EBSkyOffsY.Text = h.ceilingSkyOff.y.ToString();
            EBHorDist.Text = h.horDistance.ToString();
            EBHorPPRev.Text = h.horPixelsPerRev.ToString();
            EBHorSkyX.Text = h.horSkyOff.x.ToString();
            EBHorSkyY.Text = h.horSkyOff.y.ToString();
            EBMip1.Text = h.mipMapDist[0].ToString();
            EBMip2.Text = h.mipMapDist[1].ToString();
            EBMip3.Text = h.mipMapDist[2].ToString();
            EBMip4.Text = h.mipMapDist[3].ToString();
            EBLOD1.Text = h.LODDist[0].ToString();
            EBLOD2.Text = h.LODDist[1].ToString();
            EBLOD3.Text = h.LODDist[2].ToString();
            EBLOD4.Text = h.LODDist[3].ToString();
            EBGouraud.Text = h.gouraudDist.ToString();
            EBPerspective.Text = h.perspDist.ToString();
            EBPPU.Text = GlobalVars.Level.ppUnit.ToString();
            EBCMP.Text = GlobalVars.Level.masterCMP;
        }

        public bool NeedPreviewReload = false;

        private void LevelHeaderEditor_FormClosed(object sender, FormClosedEventArgs e)
        {
            if (DialogResult == System.Windows.Forms.DialogResult.OK)
            {
                JKLHeader h = GlobalVars.Level.header;

                double.TryParse(EBGravity.Text, out h.gravity);
                double.TryParse(EBSkyZ.Text, out h.ceilingskyZ);
                double.TryParse(EBSkyOffsX.Text, out h.ceilingSkyOff.x);
                double.TryParse(EBSkyOffsY.Text, out h.ceilingSkyOff.y);
                double.TryParse(EBHorDist.Text, out h.horDistance);
                double.TryParse(EBHorPPRev.Text, out h.horPixelsPerRev);
                double.TryParse(EBHorSkyX.Text, out h.horSkyOff.x);
                double.TryParse(EBHorSkyY.Text, out h.horSkyOff.y);
                double.TryParse(EBMip1.Text, out h.mipMapDist[0]);
                double.TryParse(EBMip2.Text, out h.mipMapDist[1]);
                double.TryParse(EBMip3.Text, out h.mipMapDist[2]);
                double.TryParse(EBMip4.Text, out h.mipMapDist[3]);
                double.TryParse(EBLOD1.Text, out h.LODDist[0]);
                double.TryParse(EBLOD2.Text, out h.LODDist[1]);
                double.TryParse(EBLOD3.Text, out h.LODDist[2]);
                double.TryParse(EBLOD4.Text, out h.LODDist[3]);
                double.TryParse(EBGouraud.Text, out h.gouraudDist);
                double.TryParse(EBPPU.Text, out GlobalVars.Level.ppUnit);
                double.TryParse(EBPerspective.Text, out h.perspDist);
                NeedPreviewReload = !GlobalVars.Level.masterCMP.Equals(EBCMP.Text, StringComparison.InvariantCultureIgnoreCase);
                GlobalVars.Level.masterCMP = EBCMP.Text;
            }
        }

        private void BNCmp_Click(object sender, EventArgs e)
        {
            string cmp = EBCMP.Text;
            ResPicker.PickCMP(ref cmp);
            EBCMP.Text = cmp;
        }
    }
}
