﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Smith.NED
{
    public class MultiSel : List<object>
    {
        public const int NMask = (-1) >> 1; // what the fuck is this about
        public const int NBit = 1 << 31;

        public void DeleteN(int n)
        {
            if ((n & NBit) == 0)
            {
                if (n < Count)
                    RemoveAt(n);
            }
        }

        public new void Sort()
        {
            // not sure about this for non-integer types.. we'll see
            Sort(delegate(object a, object b)
            {
                int i1 = (int)a;
                int i2 = (int)b;

                if (i1 > i2)
                    return 1;

                if (i1 < i2)
                    return -1;

                return 0;
            });
        }

        protected int GetInt(int n)
        {
            return (int)base[n];
        }

        private void SetInt(int n, int i)
        {
            base[n] = i;
        }

        private int AddInt(int i)
        {
            int n = Count;
            base.Add(i);
            return n;
        }

        private void InsertInt(int n, int i)
        {
            base.Insert(n, i);
        }

        public new int this[int n]
        {
            get
            {
                return GetInt(n);
            }

            set
            {
                SetInt(n, value);
            }
        }

        public int FindInt(int v)
        {
            return IndexOf(v);
        }

        protected int AddIntUnique(int v)
        {
            int i = FindInt(v);
            if (i == -1)
                return AddInt(v);

            return i | NBit;
        }
    }

    public class SCMultiSel : MultiSel
    {
        public int FindSC(int sc)
        {
            return FindInt(sc);
        }

        public int AddSC(int sc)
        {
            return AddIntUnique(sc);
        }

        public int GetSC(int n)
        {
            return GetInt(n);
        }
    }

    public class SFMultiSel : MultiSel
    {
        public int FindSF(int sc, int sf)
        {
            return FindInt(JKLevel.SFtoInt(sc, sf));
        }

        public int AddSF(int sc, int sf)
        {
            return AddIntUnique(JKLevel.SFtoInt(sc, sf));
        }

        public void GetSCSF(int n, out int sc, out int sf)
        {
            int i = GetInt(n);
            sc = JKLevel.GetsfSC(i);
            sf = JKLevel.GetsfSF(i);
        }
    }

    public class THMultiSel : MultiSel
    {
        public int FindTH(int th)
        {
            return FindInt(th);
        }

        public int AddTH(int th)
        {
            return AddIntUnique(th);
        }

        public int GetTH(int n)
        {
            return GetInt(n);
        }
    }

    /*TSCMultiSel=class(TMultiSel)
  Function FindSC(sc:integer):integer;
  function AddSC(sc:integer):integer;
  Function GetSC(n:integer):integer;
end;

TSFMultiSel=class(TMultiSel)
  Function FindSF(sc,sf:integer):integer;
  function AddSF(sc,sf:integer):integer;
  Procedure GetSCSF(n:integer;var sc,sf:integer);
end;

TTHMultiSel=class(TMultiSel)
  Function FindTH(th:integer):integer;
  function AddTH(th:integer):integer;
  Function GetTH(n:integer):integer;
end;*/

    public class LTMultiSel : MultiSel
    {
        public int FindLT(int lt)
        {
            return FindInt(lt);
        }

        public int AddLT(int lt)
        {
            return AddIntUnique(lt);
        }

        public int GetLT(int n)
        {
            return GetInt(n);
        }
    }

    public class EDMultiSel : MultiSel
    {
        public int FindED(int sc, int sf, int ed)
        {
            return FindInt(JKLevel.EDtoInt(sc, sf, ed));
        }

        public int AddED(int sc, int sf, int ed)
        {
            return AddIntUnique(JKLevel.EDtoInt(sc, sf, ed));
        }

        public void GetSCSFED(int n, out int sc, out int sf, out int ed)
        {
            int i = GetInt(n);
            sc = JKLevel.GetedSC(i);
            sf = JKLevel.GetedSF(i);
            ed = JKLevel.GetedED(i);
        }
    }

    /*TLTMultiSel=class(TMultiSel)
  Function FindLT(lt:integer):integer;
  function AddLT(lt:integer):integer;
  Function GetLT(n:integer):integer;
end;

TEDMultiSel=class(TMultiSel)
  Function FindED(sc,sf,ed:integer):integer;
  function AddED(sc,sf,ed:integer):integer;
  Procedure GetSCSFED(n:integer;var sc,sf,ed:integer);
end;*/


    public class VXMultiSel : MultiSel
    {
        public int FindVX(int sc, int vx)
        {
            return FindInt(JKLevel.VXtoInt(sc, vx));
        }

        public int AddVX(int sc, int vx)
        {
            return AddIntUnique(JKLevel.VXtoInt(sc, vx));
        }

        public void GetSCVX(int n, out int sc, out int vx)
        {
            int i = GetInt(n);
            sc = JKLevel.GetvxSC(i);
            vx = JKLevel.GetvxVX(i);
        }
    }

    public class FRMultiSel : MultiSel
    {
        public int FindFR(int th, int fr)
        {
            return FindInt(JKLevel.FRtoInt(th, fr));
        }

        public int AddFR(int th, int fr)
        {
            return AddIntUnique(JKLevel.FRtoInt(th, fr));
        }

        public void GetTHFR(int n, out int th, out int fr)
        {
            int i = GetInt(n);
            th = JKLevel.GetfrTH(i);
            fr = JKLevel.GetfrFR(i);
        }
    }

/*

TVXMultiSel=class(TMultiSel)
  Function FindVX(sc,vx:integer):integer;
  function AddVX(sc,vx:integer):integer;
  Procedure GetSCVX(n:integer;var sc,vx:integer);
end;

TFRMultiSel=class(TMultiSel)
  Function FindFR(th,fr:integer):integer;
  function AddFR(th,fr:integer):integer;
  Procedure GetTHFR(n:integer;var th,fr:integer);
end;                                        */
}
