﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Smith.NED
{
    public partial class ProgressDialog : GUI.BaseForm
    {
        public ProgressDialog()
        {
            InitializeComponent();
        }

        private static ProgressDialog dlg = null;

        private static int numsteps = 0;
        private static int fsize = 0;

        private static int curstep = 0;

        public static void Cleanup()
        {
            if (dlg != null)
            {
                dlg.Close();
                dlg.Dispose();
                dlg = null;
            }
        }

        //private static bool largemax = false;

        public static void Reset(int _numsteps, int _fsize)
        {
            Cleanup();

            //362, 98

            dlg = new ProgressDialog();
            Rectangle dbounds = (Rectangle)Box2.Around(new Box2(GlobalVars.NedMain.DesktopBounds).Center, new Vec2(dlg.Bounds.Size));
            //dlg.SetDesktopBounds(dbounds.X, dbounds.Y, dbounds.Width, dbounds.Height);
            dlg.Location = dbounds.Location;
            dlg.Show(GlobalVars.NedMain);

            curstep = 0;
            numsteps = _numsteps;
            fsize = _fsize;

            dlg.progressBar1.Minimum = 0;
            dlg.progressBar1.Step = 1;
            dlg.progressBar1.Value = 0;
            if (numsteps <= 5000)
            {
                dlg.progressBar1.Maximum = numsteps;
                //largemax = false;
            }
            else
            {
                dlg.progressBar1.Maximum = 300;
                //largemax = true;
            }
        }

        public static void Message(string msg)
        {
            dlg.PMsg.Text = msg;
            dlg.PMsg.Update();
        }

        public static void Step()
        {
            dlg.progressBar1.PerformStep();
        }

        public static void UpdateByFileRead(int filepos)
        {
            int newpos = filepos * numsteps / fsize;
            while (curstep < newpos)
            {
                curstep++;
                dlg.progressBar1.PerformStep();
            }
        }
    }
}
