﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Smith.NED
{
    public partial class SCFieldPicker : GUI.BaseForm
    {
        List<RadioButton> rbs = new List<RadioButton>();

        public int Choice
        {
            get
            {
                for (int x = 0; x < rbs.Count; x++)
                    if (rbs[x].Checked)
                        return x;

                return -1;
            }

            set
            {
                rbs[value].Checked = true;
            }
        }

        public SCFieldPicker(string title, int initialChoice, string[] options)
        {
            InitializeComponent();

            Text = title;

            rbs.Add(rb1);
            rbs.Add(rb2);
            rbs.Add(rb3);
            rbs.Add(rb4);
            rbs.Add(rb5);
            rbs.Add(rb6);

            for (int x = 0; x < rbs.Count; x++)
            {
                if (x >= options.Length)
                    rbs[x].Visible = false;
                else
                {
                    rbs[x].Text = options[x];
                    rbs[x].Visible = true;
                }
            }

            Choice = initialChoice;
        }

        public static void PickGeo(ref int geo)
        {
            geo = Math.Min(5, geo);

            SCFieldPicker fp = new SCFieldPicker("GEO mode", geo, new string[] {
                "Not rendered",
                "Draw vertices",
                "Draw wireframe",
                "Draw solid color",
                "Draw textured",
                "Draw textured"
            });

            if (fp.ShowDialog() != DialogResult.OK)
                return;

            geo = fp.Choice;
        }

        public static void PickLightMode(ref int lmode)
        {
            lmode = Math.Min(5, lmode);

            SCFieldPicker fp = new SCFieldPicker("Lighting mode", lmode, new string[] {
                "Fully lit",
                "Not lit",
                "Diffuse",
                "Gouraud",
                "Gouraud",
                "Gouraud"
            });

            if (fp.ShowDialog() != DialogResult.OK)
                return;

            lmode = fp.Choice;
        }

        public static void PickTex(ref int tex)
        {
            tex = Math.Min(3, tex);

            SCFieldPicker fp = new SCFieldPicker("Lighting mode", tex, new string[] {
                "Affine",
                "Perspective",
                "Perspective",
                "Perspective"
            });

            if (fp.ShowDialog() != DialogResult.OK)
                return;

            tex = fp.Choice;
        }
    }
}
