﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Smith.NED
{
    public partial class StringsEditor : GUI.BaseForm
    {
        public static void EditStrings(Dictionary<string, string> strs)
        {
            StringsEditor se = new StringsEditor();
            se.Set(strs);
            se.ShowDialog();
            se.Get(strs);
        }

        public void Set(Dictionary<string, string> strs)
        {
            LBStrs.BeginUpdate();
            LBStrs.Items.Clear();
            foreach (string key in strs.Keys)
                LBStrs.Items.Add(new Entry(key, strs[key]));
            LBStrs.EndUpdate();
        }

        public void Get(Dictionary<string, string> strs)
        {
            strs.Clear();
            foreach (Entry entry in LBStrs.Items)
                strs.Add(entry.Key, entry.Str);
        }

        public StringsEditor()
        {
            InitializeComponent();
        }

        class Entry
        {
            public string Key;
            public string Str;

            public override string ToString()
            {
                return Key + ": " + Str;
            }

            public Entry(string _Key, string _Str)
            {
                Key = _Key;
                Str = _Str;
            }
        }

        private void StringsEditor_Load(object sender, EventArgs e)
        {
            LBStrs.SelectedIndex = 0;
        }

        private void LBStrs_SelectedIndexChanged(object sender, EventArgs e)
        {
            Entry entry = LBStrs.SelectedItem as Entry;
            if (entry == null)
                return;

            EBKey.Text = entry.Key;
            EBStr.Text = entry.Str;
        }

        private void BNDelete_Click(object sender, EventArgs e)
        {
            while (LBStrs.SelectedIndices.Count > 0)
            {
                int i = LBStrs.SelectedIndices[0];
                LBStrs.SelectedIndices.Remove(0);
                LBStrs.Items.RemoveAt(i);
            }
        }

        private void BNAdd_Click(object sender, EventArgs e)
        {
            foreach (Entry entry in LBStrs.Items)
                if (entry.Key.Equals(EBKey.Text, StringComparison.InvariantCultureIgnoreCase))
                {
                    LBStrs.Items.Remove(entry);
                    break;
                }

            LBStrs.SelectedIndices.Clear();
            LBStrs.SelectedIndices.Add(LBStrs.Items.Add(new Entry(EBKey.Text, EBStr.Text)));
        }
    }
}
